#!/usr/bin/env python

"""
author: jun ding
date: 08/22/2013
function: this code is used to get the binding_loc for known motifs in combination
usage: 
python extend_motifs.py <motifs--.motifs file><motif combinations .mc file> <non_redundant motif hits> <non_redundant motif hits position><seqs>

"""
import pdb,sys,os
import StatTest
from StatTest import *
########################################################################


########################################################################

########################################################################
## get the target genes of each motifs 
def motTarget(m,tfbs):
	mt=[]
	# based on tfbs, we will get the targts of given motifs
	
	for i in range(len(tfbs)):
		if m in tfbs[i]:
			mt.append(i)
	return mt
	
########################################################################

########################################################################
## get the target genes of each motifs in all motif modules 
def motTargetMC(m,dmCm,mT,mc,tfbs):
	# mT  motifs->Targets list
	# dmCm motifs-> motif modules
	outT=[]
	if m in dmCm.keys():
		## motif modules having that motifs
		mCm=dmCm[m]
		mCm=mCm.split(",")
		mCm=[int(item) for item in mCm]
		mCm=[mc[item] for item in mCm]
		## motif Targets
		mTm=mT[int(m)]
		for i in mTm:
			#pdb.set_trace()
			ti=tfbs[i]
			flag=0
			for j in mCm:
				#pdb.set_trace()
				ov=[item for item in j if item in ti]
				if len(ov)==len(j):
					flag=1
					break
			if flag!=0:
				outT.append(i)
	#pdb.set_trace()					
	return outT
	




########################################################################






########################################################################


########################################################################
# read in motifs
f=open(sys.argv[1],'r')
lf=f.readlines()
f.close()
lf="".join(lf)
lf=lf.split(">")[1:]
lf=[item.split("\n") for item in lf]
for i in range(len(lf)):
	lf[i]=[item for item in lf[i] if item!=""]
	lf[i]=[lf[i][0].split()[0],len(lf[i])-1]
mot=lf


########################################################################


########################################################################
# read in motif combinations
f=open(sys.argv[2],'r')
lf=f.readlines()
f.close()
lf=[item.strip() for item in lf]
lf=[item.split()[:-2] for item in lf]
for i in range(len(lf)):
	lf[i]=[item[1:] for item in lf[i]]
mc=lf


########################################################################


########################################################################
# read in the non-redundant hits
f=open(sys.argv[3],'r')
lf=f.readlines()
f.close()
lf=[item.strip() for item in lf]
lf=[item.split() for item in lf]
hit=lf


########################################################################

########################################################################
## read in non-redundant hits position
f=open(sys.argv[4],'r')
lf=f.readlines()
f.close()
lf=[item.strip() for item in lf]
lf=[item.split() for item in lf]
pos=lf

########################################################################


########################################################################
## read in sequence
f=open(sys.argv[5],'r')
lf=f.readlines()
f.close()
lf="".join(lf)
lf=lf.split(">")[1:]
lf=[item.split("\n") for item in lf]
lf=[item for item in lf if item!=""]
lf=["".join(item[1:]) for item in lf]
Seq=lf
########################################################################


########################################################################
## Target genes for each motifs
mT=[]
for i in range(len(mot)):
	mT.append(motTarget(str(i),hit))
	#print(i)
#pdb.set_trace()

########################################################################
## Motifs in which motif modules
dmCm={}
for i in range(len(mc)):
	for j in mc[i]:
		if dmCm.has_key(j)==False:
			dmCm[j]=str(i)
		else:
			dmCm[j]+=","+str(i)
	#if i%10000==0:
		#print(i)
#pdb.set_trace()
	
#######################################################################

########################################################################
##Targets for motif in motif modules
dTm={}
for i in range(len(mot)):
	Tmc=motTargetMC(str(i),dmCm,mT,mc,hit)
	if Tmc!=[]:
		dTm[str(i)]=list(set(Tmc))
	#print(i)
		


########################################################################


########################################################################
## Hits for each motif in target genes
P=[]
for i in dTm.keys():
	T=dTm[i]
	posi=[]
	for j in T:
		indi_j=[k for k in range(len(hit[j])) if hit[j][k]==i]
		pos_ij=[pos[j][k] for k in indi_j]
		pos_ij=[str(j)+","+item for item in pos_ij]
		posi+=pos_ij
	P.append(posi)

########################################################################

########################################################################
##Get x-mers
## 24-mers
X=24 # 24-mers
x=int(mot[0][1]) # length of motif
XM=[]
for i in range(len(P)):
	XM_i=[]
	for j in range(len(P[i])):
		sid=int(P[i][j].split(",")[0])
		loc=int(P[i][j].split(",")[1])
		xm=Seq[sid][int(loc-(X-x)/2):int(loc+x+(X-x)/2)]
		XM_i.append(xm)
	XM.append(XM_i)
	
########################################################################


############################################################################
########################################################################		


########################################################################
## Getting background frequency
## 2000bps upstream of TSS, 200BP downstream of TSS , ACGT frequency in mouse, human
## approximately 
bg=[0.247,0.251,0.254,0.248]
d={"A":0,"C":1,"G":2,"T":3}
########################################################################




#########################################################################
## removing some hits nearing end, so that no extension information could be used
for i in range(len(XM)):
	XM[i]=[item for item in XM[i] if len(item)==X]
	for j in range(len(XM[i])):
		if "N" in XM[i][j]:
			XM[i][j]=""
	XM[i]=[item for item in XM[i] if item!=""]
	
########################################################################
for i in range(len(XM)):
	#pdb.set_trace()
	XM[i]=[int(list(dTm.keys())[i]),XM[i]]
XM.sort()	

XM_ID=[item[0] for item in XM]
XM=[item[1] for item in XM]
#pdb.set_trace()

###########################################################################
# output XM

T=[",".join(item) for item in XM]
T="\n".join(T)
f=open(sys.argv[1]+".XMS",'w')
f.write(T)
f.close()

# 
TID=XM_ID[:]
TID=[str(item) for item in TID]
TID="\n".join(TID)
f=open(sys.argv[1]+".XMID",'w')
f.write(TID)
f.close()
########################################################################
P=[]
cut=1e-12 # pvalue cut
Cons=[]
for i in XM:
	Pl=[] # for left
	Pr=[] # for right
	Ph=[] # for x-mer
	G=len(i)
	## handling left x-mer
	for j in range(int((X-x)/2)):
		A=[0,0,0,0]
		for k in i:
			A[d[k[j]]]+=1
		pv_a=max(0,1-pbinom(A[0]-1,G,bg[0]))
		pv_c=max(0,1-pbinom(A[1]-1,G,bg[1]))
		pv_g=max(0,1-pbinom(A[2]-1,G,bg[2]))
		pv_t=max(0,1-pbinom(A[3]-1,G,bg[3]))
		pv=[pv_a,pv_c,pv_g,pv_t]
		Pl.append(pv)
	## handling right x-mer
	
	for j in range(int((X+x)/2),int(X)):
		A=[0,0,0,0]
		for k in i:
			A[d[k[j]]]+=1
		pv_a=max(0,1-pbinom(A[0]-1,G,bg[0]))
		pv_c=max(0,1-pbinom(A[1]-1,G,bg[1]))
		pv_g=max(0,1-pbinom(A[2]-1,G,bg[2]))
		pv_t=max(0,1-pbinom(A[3]-1,G,bg[3]))
		pv=[pv_a,pv_c,pv_g,pv_t]	
		Pr.append(pv)
	## handling x-mer
	
	for j in range(int((X-x)/2),int((X+x)/2)):
		A=[0,0,0,0]
		for k in i:
			A[d[k[j]]]+=1
		pv_a=max(0,1-pbinom(A[0]-1,G,bg[0]))
		pv_c=max(0,1-pbinom(A[1]-1,G,bg[1]))
		pv_g=max(0,1-pbinom(A[2]-1,G,bg[2]))
		pv_t=max(0,1-pbinom(A[3]-1,G,bg[3]))
		pv=[pv_a,pv_c,pv_g,pv_t]	
		Ph.append(pv)
	## motif extension#################################################
	dN={"A":"A","C":"C","G":"G","T":"T","AG":"R","CT":"Y","GT":"K","AC":"M","CG":"S","AT":"W","CGT":"B","AGT":"D","ACT":"H","ACG":"V","ACGT":"N"}
	## left extension
	prefix_con=[]
	for j in range(len(Pl)-1,-1,-1):
		letter=""
		flag=0
		if Pl[j][0]<cut:
			letter+="A"
			flag+=1
		if Pl[j][1]<cut:
			letter+="C"
			flag+=1
		if Pl[j][2]<cut:
			letter+="G"
			flag+=1
		if Pl[j][3]<cut:
			letter+="T"
			flag+=1
		if flag==0:
			break
		prefix_con.append(dN[letter])
	prefix_con=prefix_con[::-1]
	## right extension
	suffix_con=[]
	for j in range(len(Pr)):
		letter=""
		flag=0
		if Pr[j][0]<cut:
			letter+="A"
			flag+=1
		if Pr[j][1]<cut:
			letter+="C"
			flag+=1
		if Pr[j][2]<cut:
			letter+="G"
			flag+=1
		if Pr[j][3]<cut:
			letter+="T"
			flag+=1
		if flag==0:
			break
		suffix_con.append(dN[letter])
	# x-mer consensus
	hit_con=[]
	for j in range(len(Ph)):
		letter=""
		flag=0
		if Ph[j][0]<cut:
			letter+="A"
			flag+=1
		if Ph[j][1]<cut:
			letter+="C"
			flag+=1
		if Ph[j][2]<cut:
			letter+="G"
			flag+=1
		if Ph[j][3]<cut:
			letter+="T"
			flag+=1
		if flag==0:
			letter+="ACGT"
		hit_con.append(dN[letter])
	#pdb.set_trace()
	con=prefix_con+hit_con+suffix_con
	con="".join(con)
	Cons.append(con)
########################################################################
## directionary for motif modules of motifs. 
dmc={}
for i in range(len(mc)):
	for j in mc[i]:
		if j not in dmc:
			dmc[j]=str(i)
		else:
			dmc[j]+=','+str(i)
			
	
########################################################################
## outputing...
out=[]
for i in range(len(XM_ID)):
	mcid=dmc[str(XM_ID[i])]
	mcid=mcid.split(",")
	mcid=[item+","+str(XM_ID[i]) for item in mcid]
	mcid=";".join(mcid)
	out.append(mcid+"\t"+Cons[i])
out="\n".join(out)
f=open(sys.argv[1]+".extended.nonred",'w')
f.write(out)
f.close()


#########################################################################
## shorting part


###################################################################################

def sub_mot(a,b):
	if len(a)>len(b):
		return False
	elif len(a)<=len(b):
		for i in range(len(b)-len(a)+1):
			flag=0
			#pdb.set_trace()
			for j in range(len(a)):
				bc=dN[b[i+j]]
				ac=dN[a[j]]
				ov=[item for item in ac if item not in bc]
				if len(ov)!=0:
					flag+=1
			if flag<=1:
				return True
		return False	
		
	
def share_mot(a,b):
	if len(a)<len(b):
		t=b
		b=a
		a=t
	a1=a[1:]
	a2=a[:-1]
	if sub_mot(a,b):
		return a
	if sub_mot(a1,b):
		return a1
	elif sub_mot(a2,b):
		return a2
	else:
		return ""
			


import pdb,sys,os
########################################################################
# read in mc
"""
f=open(sys.argv[1],'r')
lf=f.readlines()
f.close()
lf=[item.strip() for item in lf]
lf=[item.split()[:-2] for item in lf]
for i in range(len(lf)):
	lf[i]=[item[1:] for item in lf[i]]
mc=lf
"""

#######################################################################
# read in extended,non-red motifs
f=open(sys.argv[1]+".extended.nonred",'r')
lf=f.readlines()
f.close()
lf=[item.strip() for item in lf]
lf=[item.split() for item in lf]
mot=lf
#########################################################################
# 
d={"A":"A","C":"C","G":"G","T":"T","AG":"R","CT":"Y","GT":"K","AC":"M","CG":"S","AT":"W","CGT":"B","AGT":"D","ACT":"H","ACG":"V","ACGT":"N"}
dN={"A":"A","C":"C","G":"G","T":"T","R":"AG","Y":"CT","K":"GT","M":"AC","S":"CG","W":"AT","B":"CGT","D":"AGT","H":"ACT","V":"ACG","N":"ACGT"}


unextend_mot=[]
extend_mot=[]
for i in range(len(mot)):
	if len(mot[i][-1])==x:
		unextend_mot.append(mot[i])
	else:
		extend_mot.append(mot[i])


print ("motif shorten...")	
try:
	for i in range(len(unextend_mot)-1):
		for j in range(i+1,len(unextend_mot)):
			if (unextend_mot[i]!=[]) and (unextend_mot[j]!=[]):
				mt_i=unextend_mot[i][0].split(";")[0].split(",")[1]
				mt_j=unextend_mot[j][0].split(";")[0].split(",")[1]
			
				#---------------------------------------------------------
				co_i=[]
				#pdb.set_trace()
				Ti=dmc[mt_i].split(",")
				Ti=[int(item) for item in Ti]
				for k in Ti:
					k=mc[k]
					co_i+=k
				co_i=list(set(co_i))
				co_i=[item for item in co_i if item!=mt_i]
				#---------------------------------------------------------
				co_j=[]
				Tj=dmc[mt_j].split(",")
				Tj=[int(item) for item in Tj]
				for k in Tj:
					k=mc[k]
					co_j+=[item for item in k]
				co_j=list(set(co_j))
				co_j=[item for item in co_j if item!=mt_j]
			
				#pdb.set_trace()
				ov=[item for item in co_i if item in co_j]
				if len(ov)!=0:
					if len(share_mot(unextend_mot[i][-1],unextend_mot[j][-1]))!=0:
						cs=share_mot(unextend_mot[i][-1],unextend_mot[j][-1])
						if len(cs)>=x-2:
							unextend_mot[j][0]+=";"+unextend_mot[i][0]
							unextend_mot[j][1]=cs
							unextend_mot[i]=[]
							#print ("check!")
except:
	pass
	#print(i)
unextend_mot=[item for item in unextend_mot if item!=[]]

mot=unextend_mot+extend_mot
mot=["\t".join(item) for item in mot]
mot="\n".join(mot)
f=open(sys.argv[1]+".extended.nonred"+".shorten",'w')
f.write(mot)
f.close()
